/*
 *    pointers-array.cpp
 *
 *    Rodykliu ir masyvu panasumas.
 *    Rodykliu aritmetika.
 *
 */
#include <iostream>
#include <string>
#include <cstring>
using namespace std;
//------------------------------------------------------------
int main ()
{
    //
    //    masyvu ir rodykliu panasumas. rodykliu aritmetika
    //    -------------------------------------------------
    //
    int m[] = {10, 20, 30, 40, 50};
    cout << "m[1]=" << m[1] << "  m=" << m << endl;
    
    int* p = m;
    cout << "     *p=" << *p
         << "   p[0]=" << p[0]
         << "   p[3]=" << p[3] 
         << " *(p+3)=" << *(p+3) 
         << endl;
         
    const int N = 7;     
    p = new int [N];
    for (int i = 0;  i < N;  i++)
        p[i] = (i+10) * (i+10);
        
    cout << "p[N-1]=" << p[N-1] << endl;
    
    delete[] p;
    p = NULL;
    
    //
    //    char* - klasikine tekstine eilute
    //    ---------------------------------
    //
    char  eilute1[] = "pirmoji eilute";
    char* eilute2   = "antroji eilute";
    
    cout << " eilute1   = " << eilute1    << endl;
    cout << " eilute2   = " << eilute2    << endl;
    cout << " eilute2[5]="  << eilute2[5] << endl;
    cout << " \"abcd\"[2]=" << "abcd"[2]  << endl;
    
    eilute2 = eilute1;
    cout << " sizeof( eilute1)=" << sizeof( eilute1) << endl;
    cout << " sizeof( eilute2)=" << sizeof( eilute2) << endl;
    cout << " sizeof(*eilute1)=" << sizeof(*eilute1) << endl;
    cout << " sizeof(*eilute2)=" << sizeof(*eilute2) << endl;

    //
    //    string - c++'sine tekstines eilutes klase
    //    -----------------------------------------
    //
    string cppStr = "C++: Vienas du trys";
    cppStr += " keturi penki";
    cout << " cppStr=" << cppStr << endl; 
    
    char cStr [1000];
    strcpy (cStr, "C  : Vienas du trys");
    strcat (cStr, " keturi penki");
    cout << " cStr  =" << cStr << endl;
}
//============================================================
